<?php
/**
 *  QQ:2420355482   51助手网(www.51zuso.com)
 */
if(!defined('IN_DISCUZ')||$_SERVER['REQUEST_METHOD'] === 'GET') {
	exit('Access Denied');
}


//删除图片
if($_GET['delimg'] && $_GET['formhash'] == FORMHASH){ //formhash验证
	global $_G;
	$src = $_GET['src'];
	$lockaid = $_GET['lockaid'];
	$aid = $_GET['aid'];
	
	
	//解密aid与图片地址比对
	if(authcode($lockaid,'DECODE') != $src){
		exit('lockaid Access Denied');
	}
	
	//验证路径,必须在指定的目录下的图片
	//示例图片路径：http://www.dz.com/data/attachment/forum/202103/09/f2157ee98d222960ae383d939ad66da8.png'
	if(!preg_match('/^https?\:\/\/[a-z0-9\.]+\/data\/attachment\/forum\/[0-9]{6}\/[0-9]{2}\/[0-9a-z]{32}\.(png|jpg|gif|jpeg|JPG)$/',$src)){
		exit('img Access Denied');
	}
	
	
	Db::delete('forum_attachment',array('aid'=>$aid,'uid'=>$_G['uid']),1,true);
	Db::delete('forum_attachment_unused',array('aid'=>$aid,'uid'=>$_G['uid']),1,true);


	$src = str_replace($_G['siteurl'],DISCUZ_ROOT,$src);
	echo unlink($src);
	return false;
}




//获取文章代码
if($_GET['artPath']&& $_GET['formhash'] == FORMHASH){
	$artPath = $_GET['artPath'];
	$res = dfsockopen($artPath); 
	$res = getContent($res);
	//编码
	if(CHARSET != 'utf-8'){
    	$res['title'] = diconv($res['title'],'UTF-8',CHARSET);
	    $res['content'] = diconv($res['content'],'UTF-8',CHARSET);
		$res['reqUrl'] = $res['reqUrl'];
	}
	
    echo $res['title'].'-zswxcj-'.$res['content'].'-zswxcj-'.$res['reqUrl'];
}

//提取微信文章
function getContent($content){
	
	global $_G;
	
	$res = array();
	//提取标题
	preg_match_all('/id=\"activity-name\"\>([\s\S]+)\<\/h2\>/U',$content,$t);
	$res['title'] = trim($t[1][0]);
	
	//提取文章内容
	preg_match_all('/id=\"js_content\" style=\"visibility\:\s[a-z]+\;\"\>([\s\S]+)\<\/div\>/U',$content,$c);
	$content = $c[1][0];
	
	
	
	//处理svg
	preg_match_all('/<img[\s\S]+data-src=\"([\s\S]+)\"[\s\S]+\>/U',$content,$svgtag);
	foreach($svgtag[0] as $sk=>$sv){
		if(preg_match('/wx_fmt=svg/',$svgtag[1][$sk])){
			$content = str_replace($sv,'',$content);
		}
	}
	
	//处理乱码
	$content = str_replace('&quot;','',$content);
	
	
	//图片代码处理----------------
	preg_match_all('/\<img[\s\S]+data-src=\"([\s\S]+)\"[\s\S]+\">/U',$content,$i);
	$tag =$i[0];//图片标签
	foreach($tag as $k=>$v){
		$arr = explode('>',$v);
		$tag[$k]=$arr[0].'>';
	}
	$imgs = $i[1];//图片地址
	
	
	
	//图片转存到本地
	foreach($imgs as $k=>$v){
		$imgs[$k] = get_photo($v);
	}

	
	//替换图片标签 
	foreach($tag as $k=>$v){
		$lockaid = authcode($imgs[$k]['src'],'ENCODE'); //加密图片生成lockaid
		$content = str_replace($v,'<span><img lockaid="'.$lockaid.'" title="'.lang('plugin/zswxcj', 'delimg').'" class="onloadimg" style="max-width:100%;" src="'.$imgs[$k]['src'].'" aid="attachimg_'.$imgs[$k]['aid'].'"/></span>',$content);
	}
	
	//背景图片处理----------------
	preg_match_all('/url\(([\s\S]+)\);/U',$content,$bgimg);
	foreach($bgimg[1] as $bk=>$bv){
		$img = get_photo($bv);
		$restr = "url('".$img['src']."');";
		$content = str_replace($bgimg[0][$bk],$restr,$content);
		$content .= '<div style="display:none;"><img src="" aid="attachimg_'.$img['aid'].'"></div>';
	}
	
	//提取视频
	preg_match_all('/\<iframe[\s\S]+data-src=\"([\s\S]+)\"\>\<\/iframe\>/U',$content,$i);
	$videoTag = $i[0];
	$videoCode = $i[1];
	foreach($videoCode as $k=>$v){
		$vid = explode('vid=',$v)[1];
		$v = '[media=x,677,333]https://v.qq.com/x/page/'.$vid.'.html[/media]';
		$videoCode[$k] = $v;
	}
	foreach($videoTag as $k=>$v){
		$content = str_replace($v,$videoCode[$k],$content);
	}
	

	//----------------
	$res['content'] ='<div style="max-width:677px !important;">'.$content.'</div>';
	//----------------
	
	
	//图片请求 aid=
	$res['reqUrl'] = '/forum.php?mod=ajax&action=imagelist&aids=&fid='.$_G['fid'].'&inajax=1&ajaxtarget=imgattachlist';
	
	return $res;
}


//保存图片
//$url 是远程图片的完整URL地址
function get_photo($url) 
{   

	//验证图片格式
	$imgArr = array('gif','bmp','png','ico','jpg','jpeg','svg');
	if(!$url) return false;
	var_dump();
	//根据图片地址生成文件名
	preg_match('/wx_fmt=([a-z]+)/',$url,$ext); 
	$ext = $ext[1];

	
	if(!in_array($ext,$imgArr)) return false;
	$imgname= md5($url).'.'.$ext;  
	
	$attachment = date('Ym').'/'.date('d').'/'.$imgname;
	
	//生成存储文件夹
	$savefile = 'data/attachment/forum/'.date('Ym').'/'.date('d').'/';
	if(!is_dir($savefile)) mkdir($savefile, 0777,true);
	if(!is_readable($savefile)) chmod($savefile, 0777);
	$filename = $savefile.$imgname;
	
	//验证图片是否已存在
	if(checkImg($imgname)== 0){
		//存储图片到本地
		ob_start();   
		readfile($url);   
		$img = ob_get_contents();   
		ob_end_clean();   
		$size = strlen($img);   
	  
		$fp2=@fopen($filename, "a");   
		fwrite($fp2,$img);   
		fclose($fp2);   
		
		$aid = dblog($attachment,$imgname,$filename);
		
	}else{
		$aid = checkImg($imgname);
	}


	global $_G;
	return array('src'=>$_G['siteurl'].$filename,'aid'=>$aid);
	//return $filename;   
}   

//记录
function dblog($attachment,$imgname,$filename){
	
	
	global $_G;
	$uid = $_G['uid'];
	
	// forum_attachment
	$aid = Db::insert('forum_attachment',array('uid'=>$uid,'tableid'=>127),true);
	
	global $_G;
	$imgInfo = getimagesize($_G['siteurl'].$filename);
	$filesize = filesize($filename);
	
	//forum_attachment_unused
	$data = array(
	'aid'=>$aid,
	'uid'=>$uid,
	'dateline'=>time(),
	'filename'=>$imgname,
	'filesize'=>$filesize,
	'attachment'=>$attachment,
	'remote'=>0,
	'isimage'=>1,
	'width'=>$imgInfo[0],
	'thumb'=>0
	);
	Db::insert('forum_attachment_unused',$data,true);
	
	return $aid;
}



//校验图片是否已存在
function checkImg($imgname){
	$res = DB::fetch_first('SELECT * FROM %t WHERE filename=%s',array('forum_attachment_unused',$imgname));
	if($res){
		return $res['aid'];
	}else{
		return 0;
	}
}









?>